/*******************************************************************************/


window.onfocus = onfocus; 
window.onblur = onblur; 
window.onhide = onhide;
window.onshow = onshow;

/*******************************************************************************/
// for the ajax function at the bottom of the file!!!!

var newVersion = 0;

/* this current version of the widget */
var version = 1.4;


function doCheckForNewVersion(fromButton)
{
	var url="http://www.happymakinggames.com/updates.php?in_version=1.4&in_product=3&random=" + new Date().getTime();
	var req = new XMLHttpRequest();
	req.open("GET", url, true);
	req.onreadystatechange = function() 
	{ 
		if(req.readyState == 4) 
		{ 
			if(req.status == 200)
			{
				newVersion = req.responseText;
				if(newVersion > version) 
				{
					//newVersion = 1;
					document.getElementById("text_version").innerHTML = "<br>A new version (v" + newVersion + ") is available. Would you like to download it now?";
					if(fromButton == 1) 
					{
						document.getElementById("popup_version").className = "popup1";
					}
				}
				else 
				{
					document.getElementById('text_latest').innerHTML = "<br>You are using the latest version ("+version+").";
					if(fromButton == 1) 
					{
						document.getElementById("popup_latest").className = "popup1";
					}
				}
			}
		} 
	};
	req.send(null);
}

function visitDownload()
{
	var time = new Date().getTime();
	var mirror = time % 2;
	if(mirror == 1)
		widget.openURL("http://www.themessycook.com/happymakinggames/BluetoothTexter.zip");
	else
		widget.openURL("http://www.fabiopizza.com/happymakinggames/BluetoothTexter.zip");
	document.getElementById("popup_version").className = "popup0";
}


function cancelPopup(which)
{
	if(which == 0)
		document.getElementById("popup_version").className = "popup0";
	else
		document.getElementById("popup_latest").className = "popup0";
}

/*******************************************************************************
*
* select sort order
*
*******************************************************************************/

function selectSort(selectedOption)
{
	sortOrder = selectedOption.selectedIndex;
	if(sortOrder == 0)
		sortOrder = 1;
	document.getElementById('selectPerson').innerHTML = getNamesAndNumbers();	
	setSortOrderPref(sortOrder);
}

function setSortOrderPref(pref)
{
	widget.setPreferenceForKey(pref, "SortOrder");
}

/*******************************************************************************
*
* select sort order
*
*******************************************************************************/

function selectSendMethod(selectedOption)
{
	sendMethod = selectedOption.selectedIndex;
	///if(sortOrder == 0)
	//	sortOrder = 1;
	setSendMethodPref(sortOrder);
}

function setSendMethodPref(pref)
{
	widget.setPreferenceForKey(pref, "SendMethod");
}

/*******************************************************************************
*
* 
*
*******************************************************************************/


var maxMessageLength = 160;

var setupDone = false;

var sortOrder = 0;
var gInfoButton; 
var savingMode;

var len;
var checkLen;
var phoneAddress;	// btaddr of phone to use
var phoneAddressIndex;
var phoneNumber;	// number to send sms to

var lastNumbers;
var countLastNumbers;

//*** Do not change the value below, it is limited by design!!!
var maxLastNumbers = 50;

//*** Do not change the values below, it is limited to make sure the "buttons" fit in the widget size and design!!!
var maxSavedMessages = 10;
var maxSavedMessagesHalf = 5;
var SavedMessages;

var sendMethod = 0;

/*******************************************************************************
*
* SETUP, WINDOW EVENT AND PREFERENCE FUNCTONS
*
*/

function onhide()
{
	if(!setupDone)
		return;
		
	var i;
	savingMode = false;
	phoneAddressIndex = 0;;
	widget.setPreferenceForKey(phoneNumber, "LastNumber");
	widget.setPreferenceForKey(phoneAddress, "LastPhone");

	// save (or re-save) kept mesages
	for(i = 0; i < maxSavedMessages; i++)
		if(SavedMessages[i]!="")
			widget.setPreferenceForKey(SavedMessages[i], ("SavedMessages" + i));

	// save dialled phone numbers, could be a long list!!!
	for(i = 0; i < lastNumbers.length; i++)
		widget.setPreferenceForKey(lastNumbers[i], ("LastNumbers" + i));		
}


function setup() 
{
	lastNumbers = new Array();
	SavedMessages = new Array();
	getPreferences();

	gInfoButton = new AppleInfoButton(document.getElementById("infoButton"), document.getElementById("front"), "black", "black", showPrefs); 

	if(!window.BTSMSWidget)
	{
		alert("ERROR: BTSMSWidget Plugin Not Loaded. BTSMSWidget will not be functional.");	
	}
	
//	doCheckForNewVersion(1);	// false, we don't want to alert for a new version on startup!
	showBluetoothStatus();
	document.getElementById("messagePreviewBox").className = "messagePreviewBox0";
	saveButtonOnMouseOut();
	document.getElementById('selectPerson').innerHTML = getNamesAndNumbers();
	setupDone = true;
}


function onfocus() 
{ 
	if(!setupDone)
		return;
	savingMode = false;
	document.getElementById("selectPerson").innerHTML = getNamesAndNumbers(); 
	showBluetoothStatus();
} 

function onshow() 
{ 
	if(!setupDone)
		setup();
	savingMode = false;
	document.getElementById("selectPerson").innerHTML = getNamesAndNumbers(); 
	showBluetoothStatus();
} 


function onblur() 
{ 
	if(!setupDone)
		return;
	savingMode = false;
	// save preferences anyway
	onhide();
} 


function getPreferences()
{
	getSavedMessages();
	getLastNumbers();
	
	if(widget.preferenceForKey("SortOrder"))
		sortOrder = widget.preferenceForKey("SortOrder");
	else
		sortOrder = 0;
	
	if(widget.preferenceForKey("LastNumber"))
		phoneNumber = widget.preferenceForKey("LastNumber");
	else
		phoneNumber = "";
	
	if(widget.preferenceForKey("LastPhone"))
		phoneAddress = widget.preferenceForKey("LastPhone");
	else
		phoneAddress = "";
} 


function showPrefs() 
{ 
	document.getElementById("messagePreviewBox").className = "messagePreviewBox0";

    var front = document.getElementById("front"); 
    var back = document.getElementById("back"); 

    if (window.widget) 
        widget.prepareForTransition("ToBack"); 

    front.style.display="none"; 
    back.style.display="block"; 

    if (window.widget) 
        setTimeout ("widget.performTransition();", 0);  

	// get any phone list changes...
	getPhones();
} 


/*******************************************************************************
*
* BACKFACE OF WIDGET 
*
*/


function hidePrefs() 
{ 
	saveButtonOnMouseOut();
	savingMode = false;
	
    var front = document.getElementById("front"); 
    var back = document.getElementById("back"); 
    
	if (window.widget) 
        widget.prepareForTransition("ToFront"); 
    
	back.style.display="none"; 
    front.style.display="block"; 
    
	if (window.widget) 
        setTimeout ('widget.performTransition();', 0); 
} 


function visitWeb()
{
	widget.openURL("http://www.happymakinggames.com");
}


function visitFaq()
{
	widget.openURL("http://www.happymakinggames.com/downloads/BluetoothTexter/faq.php");
}


function visitFeedback()
{
	widget.openURL("http://www.happymakinggames.com/downloads/BluetoothTexter/feedback.php");
}



/*******************************************************************************
*
* STORED DIALLED NUMBERS FUNCTIONS
*
*/


function getLastNumbers()
{ 
	var text;
	var i;

	text = "<select id='selLastNumbers' onchange='selectLastNumber(this);'>";
	
	if(!widget.preferenceForKey("CountLastNumbers"))
	{
		countLastNumbers = 0;
		text = text + "<option value='0'>No previous numbers.</option>";
	}
	else
	{	
		countLastNumbers = widget.preferenceForKey("CountLastNumbers");
		
		for(i = 0; i < maxLastNumbers; i++)
			if(widget.preferenceForKey(("LastNumbers" + i)))
				lastNumbers.push( widget.preferenceForKey(("LastNumbers" + i)) );

		text = text + "<option value='0'>Last numbers...</option>";

		for(i = 0; i < lastNumbers.length; i++)
			text = text + "<option value='" + (i+1) + "'>" + lastNumbers[i] + "</option>";
	}
	
	text = text + "</select>";
	document.getElementById("lastNumbers").innerHTML = text;
}


function saveLastNumbers(num)
{
	var text;
	var i;

	// remove last item if array is "full"
	if(lastNumbers.length >= maxLastNumbers)
		lastNumbers.pop();	

	// add new number to beginning of array
	var idx = document.getElementById("selPerson").selectedIndex;
	if(idx < 2)
	{
		countLastNumbers = lastNumbers.unshift(num);
	}
	else
	{
		countLastNumbers = lastNumbers.unshift(document.getElementById("selPerson").options[idx].text);
	}

	// maybe remove duplicates?
	for(i = countLastNumbers - 1; i > 0 ; i--)
		if(lastNumbers[0] == lastNumbers[i])
			lastNumbers.splice(i, 1);
	
	countLastNumbers = lastNumbers.length;

	// set the aray length as a preference	
	widget.setPreferenceForKey(countLastNumbers, "CountLastNumbers");		
	
	// save the re-ordered array
	for(i = 0; i < countLastNumbers; i++)
		widget.setPreferenceForKey(lastNumbers[i], ("LastNumbers" + i));		

	// make sure the selection drop down reflects the new array
	text = "<select id='selLastNumbers' onchange='selectLastNumber(this);'>";
	
	if(countLastNumbers == 0)
		text = text + "<option value='0'>No previous numbers</option>";
	else
	{
		text = text + "<option value='0'>Choose a previous number</option>";
		for(i = 0; i < countLastNumbers; i++)
			text = text + "<option value='" + (i+1) + "'>" + lastNumbers[i] + "</option>";
	}
	
	text = text + "</select>";
	document.getElementById("lastNumbers").innerHTML = text;
}


function selectLastNumber(selectedOption)
{
	phoneNumber = lastNumbers[selectedOption.selectedIndex - 1];
	document.getElementById("textField").value = phoneNumber;
	document.getElementById("selPerson").selectedIndex = 1;	// other
	widget.setPreferenceForKey(phoneNumber, "LastNumber");
	limitNumber(document.getElementById("textField"));
	//lastNumberMouseOver(); ?? why was this still here?
}


//function rearSelectorMouseOver(elid)
//{
//	document.getElementById(elid).className = "rearSelector1";
//}
//
//
//function rearSelectorMouseOut(elid)
//{
//	document.getElementById(elid).className = "rearSelector0";
//}
//

/*******************************************************************************
*
* STORED PRESET MESSAGE FUNCTIONS
*
*/

function getSavedMessages()
{
	var text;
	var i;
	var target;
	var topLeft;
	
	for(i = 0; i < maxSavedMessages; i++)
	{
		if(widget.preferenceForKey( ("SavedMessages" + i) ))
		{
			document.getElementById(("messageImage" + i)).src = "images/normal.png";	
			text = widget.preferenceForKey( ("SavedMessages" + i) );
		}
		else
		{
			text = "";
		}
		SavedMessages[i] = text;
	}
}


function showPrefsWithSavingMode()
{
	document.getElementById("messagePreviewBox").className = "messagePreviewBox0";
	document.getElementById("error").innerText = "Select the message to save to";	
	savingMode = true;
	showPrefs();
}


function messageOnMouseOver(element, idx)
{
	// if savingMode is true then we show a red coloured image
	// if savingMode is false we show a green (or "lighter")
	if(idx < maxSavedMessagesHalf)
		document.getElementById("messagePreviewBox").className = "messagePreviewBox1";
	else
		document.getElementById("messagePreviewBox").className = "messagePreviewBox2";

	if(savingMode)
	{
		element.src = "images/change.png";
		document.getElementById("messagePreview").color = "#f30";	
		document.getElementById("messagePreview").innerText = SavedMessages[idx];
		document.getElementById("error").innerText = "Select a message, phone or number";	
	}
	else
	{
		element.src = "images/hover.png";
		if(SavedMessages[idx] == "")
			document.getElementById("messagePreviewBox").className = "messagePreviewBox0";
		else
		document.getElementById("messagePreview").innerText = SavedMessages[idx];
	}
}

 
function messageOnMouseOut(element, idx)
{
	if(SavedMessages[idx]!="")
		element.src = "images/normal.png";
	else
		element.src = "images/empty.png";	
	document.getElementById("messagePreviewBox").className = "messagePreviewBox0";
}


function clickSavedMessage(idx)
{
	if(savingMode)
	{
		SavedMessages[idx] = document.getElementById("textInput").value;
		document.getElementById("messagePreview").innerText = SavedMessages[idx];
		widget.setPreferenceForKey(SavedMessages[idx], ("SavedMessages" + idx));
		document.getElementById(("messageImage" + idx)).src = "images/normal.png";
		savingMode = false;
		hidePrefs();
	}
	else
	{
		document.getElementById("textInput").innerText = SavedMessages[idx];
		countChars(document.getElementById("textInput"));
	}
}
 
 
function saveButtonOnMouseOver(element)
{
	document.getElementById("saveButton").className = "saveButton1";
	document.getElementById("saveButtonTextBox").className = "saveButtonText1";
}

 
function saveButtonOnMouseOut(element)
{
	document.getElementById("saveButton").className = "saveButton0";
	document.getElementById("saveButtonTextBox").className = "saveButtonText0";
}


/*******************************************************************************
*
* STATUS FUNCTIONS
*
*/


function showBluetoothStatus()
{
	var status = window.BTSMSWidget.getBluetoothStatus();
	switch(status)
	{
		default:
		case 0:
		case 2:
			// no bluetooth
			document.getElementById("status").innerHTML = "<span>Bluetooth hardware not installed</span><img src='images/btr.png' />";
			break;
		case 1:
			// bluetooth not turned on
			document.getElementById("status").innerHTML = "<span>Bluetooth not turned on</span><img src='images/bto.png' />";
			break;
		case 3:
			// bluetooth on
			document.getElementById("status").innerHTML = "<span>Bluetooth is on</span><img src='images/btb.png' />";
			break;
	}
}


/*******************************************************************************
*
* PHONE DEVICE SELECTION AND ARRAY LOADING
*
*/


function selectPhone(selectedOption)
{
	savingMode = false;
	phoneAddress = window.BTSMSWidget.selectPhone_(selectedOption.selectedIndex);
	phoneAddressIndex = document.getElementById("selPhone").selectedIndex;
	widget.setPreferenceForKey(phoneAddress, "LastPhone");
}


function getPhones()
{ 
	if(!window.BTSMSWidget)
	{
		alert("ERROR: Widget plugin dead!");
		return;
	}

	window.BTSMSWidget.getBluetoothPhoneDevices();
	var array = window.BTSMSWidget.getPhoneDevices();
	var items = window.BTSMSWidget.getPhoneDevicesCount();
	var text;
	var i;

	text = "<select id='selPhone' onchange='selectPhone(this);'>";
	if(items == 0)
		text = text + "<option value='0'>Phones</option>";
	else
		for(i = 0; i < items; i++)
			text = text + "<option value='" + i + "'>" + array[i] + "</option>";

	text = text + "</select>";
	document.getElementById("selectPhone").innerHTML = text;
	document.getElementById("selPhone").selectedIndex = phoneAddressIndex;	
}


/*******************************************************************************
*
* ACTUAL MESSAGE SENDING
*
*/


function sendMessage()
{
	document.getElementById("length").innerText = "Sending...";
	// some sort of wait required for text to appear???
	if((checkLen - len) > 0)
	{
		phoneNumber = document.getElementById("textField").value;
		saveLastNumbers(phoneNumber);
		document.getElementById("length").innerText = (widget.system("./BTSMSWidget.widgetplugin/Contents/Resources/sendsms " + 
																	sendMethod + " " + phoneAddress + " " + phoneNumber + " \"" + 
																	document.getElementById("textInput").value + "\"", 
																	null).outputString);
	}
	else
		if((checkLen - len) == 0)
			document.getElementById("length").innerText = "No message."
		else
			document.getElementById("length").innerText = "SMS too long."
}


/*******************************************************************************
*
* DESTINATION NUMBER SELECTION AND ARRAY LOADING
*
*/


function selectNumber(selectedOption)
{
	phoneNumber = window.BTSMSWidget.selectNumber_(selectedOption.selectedIndex);
	document.getElementById("textField").value = phoneNumber;
	countChars(document.getElementById("textField"));
	widget.setPreferenceForKey(phoneNumber, "LastNumber");
	//personMouseOver();
}


function getNamesAndNumbersAgain()
{
	document.getElementById("selectPerson").innerHTML = getNamesAndNumbers();
}


function getNamesAndNumbers()
{ 
	if(!window.BTSMSWidget)
	{
		alert("ERROR: Widget plugin dead!");
		return;
	}

	// sort order for getAddressbookItems_() 0 for (last, first, number) 1 for (first, last, number)
	window.BTSMSWidget.getAddressbookItems_(sortOrder);
	var array = window.BTSMSWidget.getNamesWithNumbersArray();
	var items = window.BTSMSWidget.getNameAndNumberCount();
	var text;
	var i;

	text = "<select id='selPerson' onchange='selectNumber(this);'>";
	if(items == 0)
		text = text + "<option value='0'>Addressbook</option>";
	else
		for(i = 0; i < items; i++)
			text = text + "<option value='" + i + "'>" + array[i] + "</option>";
		
	text = text + "</select>";
	
	return text;
}


/*******************************************************************************
*
* INPUT VALIDATION
*
*/


function countChars(element)
{
	checkLen = maxMessageLength;
	len = element.value.length;
	document.getElementById("length").innerText = "Available: " + (checkLen - len) + " of " + checkLen;
	if(len > checkLen)
		document.getElementById("length").className = "lengthBad";
	else
		document.getElementById("length").className = "lengthGood";
}


function limitNumber(element)
{
	var ch = '';
	var i = 0;
	var newstring = "";
	var oldstring = element.value;
	var len = element.value.length;
	for(i = 0; i < len; i++) 
	{
		ch = oldstring.substring(i, i + 1);
		if((ch >= '0' && ch <= '9') || ch == '+')
			newstring += ch;
	}
	phoneNumber = newstring;
	element.value = newstring;
}


/*******************************************************************************/


